﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Globalization;



/// <summary>
/// Contains the Response-Data from an REST Search Request.
/// </summary>
namespace MVB_RestBookService
{
    //Root Element
    public class JsonDataContainerDetail
    {
        public string id = "";

        public string publicationDate = "";
        public string availability = "";
        public string publishingStatus = "";
        public string createdDate = "";
        public string lastModifiedDate = "";

        public Classifications[] classifications;
        public Collections[] collections;
        public Contributors[] contributors;
        public Extent extent;
        public Productform form; //Form had to be renamed to Productform to avoid issues (bugs?) with the VS UI-Designer!!
        public Identifiers[] identifiers;
        public MediaFiles[] mediaFiles;
        public Prices[] prices;
        public Publishers[] publishers;
        public Texts[] texts;
        public Titles[] titles;
		public WebSites[] webSites;
        public Wholesalers[] wholesalers;
    }



    //Classifications Composite
    public class Classifications
    {
        public string id = "";
        public string type = "";
        public string systematicVersion = "";
        public string code = "";
        public string value = "";
        public string schemeName = "";
        public string sourceName = "";
        public string main = "";
    }



    //Collections Composite
    public class Collections
    {
        public string id = "";
        public Master master = new Master();
        public string sequence = "";
        public string levelSequence = "";
        public string titleInCollection = "";
    }



    //Contributors Composite
    public class Contributors
    {
        public string id = "";
        public string sequence = "";
        public string type = "";
        public string sequenceWithinRole = "";
        public string firstName = "";
        public string lastName = "";
        public string groupName = "";
        public string dnbId = "";
        public string professionalAffiliation = "";
        public string professionalPosition = "";
        public string biographicalNote = "";
        public string dateOfBirth = "";
        public string dateOfDeath = "";
        public string dateOfBirthFormat = "";
        public string dateOfDeathFormat = "";
        public string language = "";
		public WebSites[] webSites = new WebSites[0];
        public string company = "";
        public string fullName = "";
        public string value = "";
    }



    //Extent Composite
    public class Extent
    {
        public string extent = "";
        public string duration = "";
        public string durationUnitCode = "";
        public string fileSize = "";
        public string fileSizeUnitCode = "";
        public string mapScale = "";
        public string numIllustrations = "";
        public string numTracks = "";
        public string illustrationText = "";
        public string pages = "";
        public string pagesRoman = "";
        public string pagesArabic = "";
        public string fileFormat = "";
        public string epubTypeDescription = "";
        public string drm = "";
        public string drmCode = "";
        public string epubTypeVersion = "";
    }



    //Form Composite
    public class Productform
    {
        public string id = "";
        public string type = "";
        public string binding = "";
        public string description = "";
        public string detail = "";
        public string diameter = "";
        public string height = "";
        public string width = "";
        public string weight = "";
        public string thickness = "";
        public string packaging = "";
        //public string productContentType= "";
        public string numberOfPieces = "";
    }



    //Identifiers Composite
    public class Identifiers
    {
        public string id = "";
        public string typeName = "";
        public string type = "";
        public string value = "";
    }



    //Master Composite (Child of Collections Composite)
    public class Master
    {
        public string id = "";
        public string type = "";
        public Identifiers[] identifiers = new Identifiers[0];
        public string title = "";
        public string abbreviatedTitle = "";
        public string subtitle = "";
        public string publisherId = "";
        public string publisherNameVlb = "";
        public string publisherNameAdb = "";
        public string lastModifiedDate = "";
        public string active = "";
        public string bitNo = "";
        public string aggregatorId = "";
        public string concatenateTitle = "";
        public string concatenateSubtitle = "";
    }



    //MediaFiles Composite
    public class MediaFiles
    {
        public string id = "";
        public string type = "";
        public string format = "";
        public string linkType = "";
        public string value = "";
        public string fileDate = "";
        public string imageResolution = "";
        public string validFrom = "";
        public string validUntil = "";
        public string assetFileId = "";
        public string externallyGenerated = "";
    }



    //Prices Composite
    public class Prices
    {
        public string id = "";
        public string type = "";
        public string country = "";
        public string territory = "";
        public string currency = "";
        public string validFrom = "";
        public string validUntil = "";
        public string state = "";
        public string taxRate = "";
        public string value = "";
        public string typeQualifier = "";
        public string typeDescription = "";
        public string discountCodeText = "";
        public string minimumQuantity = "";
        public string priceTypeGroup = "";
        public string fixedRetailPrice = "";
        public string provisional = "";
    }



    //Publisher Composite
    public class Publishers
    {
        public string id = "";
        public string type = "";
        public string name = "";
        public string adbName = "";
        public string nameCodeType = "";
        public string publisherId = "";
        public string imprint = "";
		public WebSites[] webSites = new WebSites[0];
    }



    //Texts Composite
    public class Texts
    {
        public string id = "";
        public string type = "";
        public string formatCode = "";
        public string language = "";
        public string value = "";
        public string linkType = "";
        public string link = "";
        public string validFrom = "";
        public string validUntil = "";
        public string textPublicationDate = "";
    }



    //Titles Composite
    public class Titles
    {
        public string id = "";
        public string type = "";
        public string subtitle = "";
        public string title = "";
    }



	//WebSites Composite
	public class WebSites
	{
		public string id = "";
		public string type = "";
		public string url = "";
		public string description = "";
		public string productSpecific = "";
	}



    //Wholesalers Composite
    public class Wholesalers
    {
        public string id = "";
        public string isbn = "";
        public string sigl = "";
        public string orderNumber = "";
        public string recordSource = "";
    }
}
