﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;



namespace MVB_RestBookService
{
    public partial class LoginDataFrame : Form
    {
        //Members
        public string password;



        public LoginDataFrame(string password)
        {
            InitializeComponent();

            this.password = password;

            //Read Login Data from File
            try
            {
                if (File.Exists("loginData.conf"))
                {
                    //Open Stream
                    FileStream fileStream = new FileStream("loginData.conf", FileMode.Open);
                    StreamReader streamReader = new StreamReader(fileStream);

                    //Variables
                    string encryptedAccount = streamReader.ReadLine();
                    string encryptedPasswort = streamReader.ReadLine();
                    string encryptedMetadataToken = streamReader.ReadLine();
                    string encryptedCoverToken = streamReader.ReadLine();
                    string encryptedMediaToken = streamReader.ReadLine();

                    //Read Data
                    waterMarkTextBox_loginDataFrame_account.Text = encryptedAccount.Equals("") ? "" : Encryption.DecryptStringAES(encryptedAccount, password);
                    waterMarkTextBox_loginDataFrame_password.Text = encryptedPasswort.Equals("") ? "" : Encryption.DecryptStringAES(encryptedPasswort, password);

                    //Close Stream
                    streamReader.Close();
                    fileStream.Close();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Ein Fehler ist aufgetreten:\n\nDas eingegebene Passwort ist wahrscheinlich nicht korrekt.\nBitte starten Sie Rest Book Service neu und geben Sie das korrekte Passwort an.", "Fehler");
                button_loginDataFrame_ok.Enabled = false;
                return;
            }
        }



        private void button_loginDataFrame_ok_Click(object sender, EventArgs e)
        {
            //Variables
            string encryptedAccount = waterMarkTextBox_loginDataFrame_account.Text;
            string encryptedPasswort = waterMarkTextBox_loginDataFrame_password.Text;

            try
            {
                //Encrypt
                if (!encryptedAccount.Equals(""))
                {
                    encryptedAccount = Encryption.EncryptStringAES(encryptedAccount, password);
                }

                if (!encryptedPasswort.Equals(""))
                {
                    encryptedPasswort = Encryption.EncryptStringAES(encryptedPasswort, password);
                }

                //Open Stream
                FileStream fileStream = new FileStream("loginData.conf", FileMode.Create);
                StreamWriter streamWriter = new StreamWriter(fileStream);

                //Write Data
                streamWriter.WriteLine(encryptedAccount);
                streamWriter.WriteLine(encryptedPasswort);

                //Close Stream
                streamWriter.Flush();
                streamWriter.Close();
                fileStream.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show("Ein Fehler ist aufgetreten:\n\n" + ex.Message, "Fehler");
                return;
            }

            MessageBox.Show("Ihre Zugangsdaten werden erst beim nächsten Programmstart übernommen!\nBitte Starten Sie das Program neu.", "Info");

            this.Close();
        }



        private void button_loginDataFrame_cancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        
    }
}
